{$A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 2048,0,655360}

const
  Base = $80000;
  Ofs1 = $80000 - Base;
  Ofs2 = $C0000 - Base;
  Ofs3 = $F7FFE - Base;

  Header: Array [0..$19] of Byte = (
  { ^BE^GHmX<Tab><Backspace> (the AT command used by SDL.EXE) with each
    byte NOT'ed is used as the Xmodem SDL signature (first line here)... }
    $FD, $BA, $F8, $B7, $92, $A7, $F6, $F7,
    $01, $55, $00, $00, $80, $00, $00, $00,
    $04, $02, $00, $E2, $04, $02, $09, $0C,
    $0D, $00);

var
  CRC, CRC1: Word;
  XorVal: Byte;
  f1, f2: File;
  Pos: LongInt;
  Buf: Array [0..16383] of Byte;
  BufPos, BufCnt: Integer;

procedure UpdateCRC(Current: Byte); assembler;
asm
  mov    al,Current
{ This code is ripped out from the SDL "as is" }
  mov    dx,CRC
  xor    al,dl
  mov    dl,al
  mov    ah,0
  shl    ax,4
  xor    dx,ax
  shr    ax,1
  xchg   dh,dl
  xor    dx,ax
  shl    ax,4
  and    ah,7
  xor    dx,ax
  shl    ax,1
  xor    dl,ah
  mov    CRC,dx
end;

begin
  WriteLn(#13#10'USR Courier Xmodem SDL Generator  Copyright (c) 1996 by Solar Designer'#13#10);

  if ParamCount<>2 then
  begin
    WriteLn('Usage: XMODEM.EXE <source> <target>'); Halt;
  end;

  Assign(f1, ParamStr(1)); Reset(f1, 1);
  Pos:=Ofs1; Seek(f1, Pos);

  Assign(f2, ParamStr(2)); Rewrite(f2, 1);
  Seek(f2, 128);

  CRC:=$FFFF; XorVal:=$55;
  repeat
    BlockRead(f1, Buf, SizeOf(Buf), BufCnt);
    if Pos+BufCnt>Ofs3 then BufCnt:=Ofs3-Pos;
    for BufPos:=0 to BufCnt-1 do
    begin
      if Pos+BufPos=Ofs2 then
      begin
        CRC1:=CRC; CRC:=$FFFF;
      end else
      if Pos+BufPos=Ofs3-2 then Buf[BufPos]:=Lo(CRC1) else
      if Pos+BufPos=Ofs3-1 then Buf[BufPos]:=Hi(CRC1);

      UpdateCRC(Buf[BufPos]); Buf[BufPos]:=Buf[BufPos] xor XorVal;

      if (Pos+BufPos) and $7F = $7F then
      begin
        BlockWrite(f2, Buf[BufPos-$7F], $80); XorVal:=Buf[BufPos] xor XorVal;
      end;
    end;
    Inc(Pos, BufCnt);
  until (BufCnt=0) or (Pos>=Ofs3);

  Seek(f1, Ofs3-$7E);
  BlockRead(f1, Buf, $80);
  for BufPos:=0 to $7F do Buf[BufPos]:=Buf[BufPos] xor XorVal;
  FillChar(Buf[$7C], 4, 0);
  BlockWrite(f2, Buf, $80);

  Pos:=Ofs3+2; Seek(f1, Pos);
  repeat
    BlockRead(f1, Buf, SizeOf(Buf), BufCnt);
    for BufPos:=0 to BufCnt-1 do
    begin
      Buf[BufPos]:=Buf[BufPos] xor XorVal;

      if (Pos+BufPos) and $7F = $7F then
      begin
        BlockWrite(f2, Buf[BufPos-$7F], $80); XorVal:=Buf[BufPos] xor XorVal;
      end;
    end;
    Inc(Pos, BufCnt);
  until BufCnt=0;

  Header[$A]:=Hi(CRC); Header[$B]:=Lo(CRC);
  for BufPos:=0 to $18 do Inc(Header[$19], Header[BufPos]);

  for BufPos:=0 to $7F do
  if BufPos<=High(Header) then Buf[BufPos]:=Header[BufPos] xor $4A
  else Buf[BufPos]:=$4A;

  Seek(f2, 0);
  BlockWrite(f2, Buf, $80);

  Close(f2); Close(f1);
end.


